uniform float Theight;
uniform int Tlength, Twidth;
//uniform sampler2D normalMap;
uniform float texRep, detailRep;
uniform bool lighting;
uniform bool textureLOD;
//varying float h;
varying vec3 lightDir;
varying float distance;
varying float lodLevel;
varying float smoothLod;

varying float test;

float rep1;
float rep2;

void calculateTexLOD()
{
	float currentCutoff = 15.0;
    	float finalCutoff = 15.0;
	int lod = 1;
	int i = 6;
    	for (int j = 1; j < 7; j++)
    	{
	  	currentCutoff *= 2.0;
	  	lod = step(currentCutoff,distance);
        	//finding the first cutoff that is larger than
		//the current distance
		if ((lod == 0) && (i==6))
	  	{
			i = j;
			finalCutoff = currentCutoff;
	  	}
    	}
	lodLevel = i;
	smoothLod = smoothstep(finalCutoff/2.0,finalCutoff,distance);
	//PROBLEM: if i changes across one polygon, texture repetition 	//goes weird...need to somehow relegate this situation to the
	//fragment shader...?
	rep1 = 10*pow(0.5,i-2.0);
    	rep2 = rep1/2.0;
	test = i;
}

void main()
{ 
	vec3 vVertex = vec3(gl_ModelViewMatrix * gl_Vertex);
	distance = length(vVertex);

	if (textureLOD) calculateTexLOD();
	else 
	{
		rep1 = 1;
		rep2 = 1;
	}

	//Lighting
	if (lighting)
		lightDir = vec3(gl_LightSource[0].position.xyz - vVertex);

	//Texture Coordinates
	float x = gl_Vertex.x/Twidth;
	float z = gl_Vertex.z/Tlength;
	float y = gl_Vertex.y / Theight;
	//h = y;

	//height width ratio
	float ratio = Theight/Twidth;
	y *= ratio;

	float texX, texZ;
	float texX2, texZ2;
	float texX3, texZ3;

	float texX4, texZ4;

	//normal projection. use x and z to sample texture
	texX = x*texRep*rep1;
	texZ = z*texRep*rep1;

	texX4 = x*texRep*rep2;
	texZ4 = z*texRep*rep2;

	// projection2. x is largest normal component so use z and y to sample texture
	texX2 = texZ;
	texZ2 = y*texRep;

	// projection3. z is largest normal component so use x and y to sample texture
	texX3 = texX;
	texZ3 = texZ2; //y

	gl_TexCoord[0] = vec4(texX,texZ,0,0);  //first projection
	gl_TexCoord[1] = vec4(texX2,texZ2,0,0);  //second projection
	gl_TexCoord[2] = vec4(texX3,texZ3,0,0);  //third projection
	
	gl_TexCoord[3] = vec4(x*detailRep,z*detailRep,0,0); //detail proj1  
	gl_TexCoord[4] = vec4(texX2/texRep*detailRep,texZ2/texRep*detailRep,0,0); //detail proj2 
	gl_TexCoord[5] = vec4(texX3/texRep*detailRep,texZ3/texRep*detailRep,0,0); //detail proj3 

	gl_TexCoord[6] = vec4(x,z,0,0); //normal map

	gl_TexCoord[7] = vec4(texX4,texZ4,0,0);

	gl_Position = ftransform();
}
